/**
 * SKA LOW Sensitivity Calculator API
 * The SKA LOW Sensitivity Calculator API offers three modes: continuum, zoom and PSS.  Each of these has an API resource to calculate a sensitivity for an observation. Continuum and zoom have another to retrieve information relating to image weighting (beam-size and relative sensitivity).  There is also a resource for obtaining subarray information. 
 *
 * The version of the OpenAPI document: 10.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent, HttpParameterCodec, HttpContext 
        }       from '@angular/common/http';
import { CustomHttpParameterCodec }                          from '../encoder';
import { Observable }                                        from 'rxjs';

// @ts-ignore
import { LowContinuumSensitivityResponse } from '../ska_ost_senscalc_ui.app.generated.api.low.model/continuumSensitivityResponse';
// @ts-ignore
import { LowContinuumWeightingResult } from '../ska_ost_senscalc_ui.app.generated.api.low.model/continuumWeightingResult';
// @ts-ignore
import { LowErrorModel } from '../ska_ost_senscalc_ui.app.generated.api.low.model/errorModel';
// @ts-ignore
import { LowPssSensitivityResponse } from '../ska_ost_senscalc_ui.app.generated.api.low.model/pssSensitivityResponse';
// @ts-ignore
import { LowSingleWeightingZoomResult } from '../ska_ost_senscalc_ui.app.generated.api.low.model/singleWeightingZoomResult';
// @ts-ignore
import { LowSingleZoomSensitivityResponse } from '../ska_ost_senscalc_ui.app.generated.api.low.model/singleZoomSensitivityResponse';
// @ts-ignore
import { LowSubarraysResponse } from '../ska_ost_senscalc_ui.app.generated.api.low.model/subarraysResponse';

// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { LowConfiguration }                                     from '../configuration';


export interface SkaOstSenscalcLowApiContinuumCalculateRequestParams {
    /** Enumeration of the SKA LOW subarray configurations allowed for a continuum calculation. To define a custom configuration, set num_stations and do not set this parameter. */
    subarrayConfiguration?: 'LOW_AA05_all' | 'LOW_AA1_all' | 'LOW_AA2_all' | 'LOW_AA2_core_only' | 'LOW_AAstar_all' | 'LOW_AAstar_core_only' | 'LOW_AA4_all' | 'LOW_AA4_core_only';
    /** The number of LOW antenna stations. If set, subarray_configuration should not be set. */
    numStations?: number;
    /** The integration time of the observation in hours */
    integrationTimeH?: number;
    /** Pointing centre in HH:MM:SS[.ss] [+|-]DD:MM:SS[.ss] */
    pointingCentre?: string;
    /** Lowest elevation that the LOW observation will be performed at. The maximum value is nominally 90 degrees, but the enforced limit is actually the highest elevation that can be achieved given the source declination and the latitude of the telescope. */
    elevationLimit?: number;
    /** Central frequency in MHz. Combined with the bandwidth_mhz, it must define a spectral window that is contained within the Low frequency range. */
    freqCentreMhz?: number;
    /** Factor by which the spectral resolution should be averaged to calculate the effective resolution which is used in the calculation. The number of channels is set by the continuum bandwidth and the maximum value of the spectral averaging factor is half that number. */
    spectralAveragingFactor?: number;
    /** Bandwidth for the continuum observation in MHz. Combined with the freq_centre_mhz, it must define a spectral window that is contained within the Low frequency range. */
    bandwidthMhz?: number;
    /** If this parameter is provided, the \&#39;subbands\&#39; field in the response body will contain a sensitivity result  for each sub-band, which is calculated by dividing the bandwidth in N sub-bands. If the value is given as 1 then  this is equal to the main sensitivity calculation so no \&#39;subbands\&#39; are returned in the response.  */
    nSubbands?: number;
}

export interface SkaOstSenscalcLowApiContinuumWeightingRequestParams {
    /** Enumeration of the spectral mode to use to in the weighting look up table.  */
    spectralMode: 'continuum' | 'line';
    /** Enumeration of the weighting strategy used. */
    weightingMode: 'natural' | 'robust' | 'uniform';
    /** Pointing centre in HH:MM:SS[.ss] [+|-]DD:MM:SS[.ss] */
    pointingCentre: string;
    /** Central frequency in MHz. Combined with the bandwidth_mhz, it must define a spectral window that is contained within the Low frequency range. */
    freqCentreMhz: number;
    /** Robust parameter. Only required and considered if the weighting is set to robust. */
    robustness?: -2 | -1 | 0 | 1 | 2;
    /** Enumeration of the SKA LOW subarray configurations allowed for a continuum calculation. To define a custom configuration, set num_stations and do not set this parameter. */
    subarrayConfiguration?: 'LOW_AA05_all' | 'LOW_AA1_all' | 'LOW_AA2_all' | 'LOW_AA2_core_only' | 'LOW_AAstar_all' | 'LOW_AAstar_core_only' | 'LOW_AA4_all' | 'LOW_AA4_core_only';
    /** Central frequency of each sub-band in MHz. Providing sub-band frequencies enables the provision of additional weighting outputs. */
    subbandFreqCentresMhz?: Array<number>;
}

export interface SkaOstSenscalcLowApiPssCalculateRequestParams {
    /** Enumeration of the SKA LOW subarray configurations allowed for a PSS calculation. To define a custom configuration, set num_stations and do not set this parameter. */
    subarrayConfiguration?: 'LOW_AA2_core_only' | 'LOW_AAstar_core_only' | 'LOW_AA4_core_only';
    /** The number of LOW antenna stations. If set, subarray_configuration should not be set. */
    numStations?: number;
    /** The integration time of the observation in hours */
    integrationTimeH?: number;
    /** Pointing centre in HH:MM:SS[.ss] [+|-]DD:MM:SS[.ss] */
    pointingCentre?: string;
    /** Lowest elevation that the LOW observation will be performed at. The maximum value is nominally 90 degrees, but the enforced limit is actually the highest elevation that can be achieved given the source declination and the latitude of the telescope. */
    elevationLimit?: number;
    /** Central frequency in MHz. Combined with the bandwidth_mhz, it must define a spectral window that is contained within the Low frequency range. */
    freqCentreMhz?: number;
    /** Dispersion Measure in pc/cm^3 */
    dm?: number;
    /** Intrinsic pulse width in milliseconds. This must be less than the pulse period. */
    intrinsicPulseWidth?: number;
    /** Pulse period in milliseconds. */
    pulsePeriod?: number;
}

export interface SkaOstSenscalcLowApiZoomCalculateRequestParams {
    /** Enumeration of the SKA LOW subarray configurations allowed for a zoom calculation. To define a custom configuration, set num_stations and do not set this parameter. */
    subarrayConfiguration?: 'LOW_AA2_all' | 'LOW_AA2_core_only' | 'LOW_AAstar_all' | 'LOW_AAstar_core_only' | 'LOW_AA4_all' | 'LOW_AA4_core_only';
    /** The number of LOW antenna stations. If set, subarray_configuration should not be set. */
    numStations?: number;
    /** The integration time of the observation in hours */
    integrationTimeH?: number;
    /** Pointing centre in HH:MM:SS[.ss] [+|-]DD:MM:SS[.ss] */
    pointingCentre?: string;
    /** Lowest elevation that the LOW observation will be performed at. The maximum value is nominally 90 degrees, but the enforced limit is actually the highest elevation that can be achieved given the source declination and the latitude of the telescope. */
    elevationLimit?: number;
    /** Array of the central frequency of each zoom windows in MHz. Combined with the total_bandwidths_khz, each must define a spectral window that is contained within the Low frequency range. */
    freqCentresMhz?: Array<number>;
    /** Factor by which the spectral resolution should be averaged to calculate the effective resolution which is used in the calculation. The maximum value is set to half the number of channels in a zoom window. */
    spectralAveragingFactor?: number;
    /** Spectral resolution/channel width of each of the the zoom window. The channel width of the narrowest zoom window is given by (781250 * 32/27)/(4096 * 16) &#x3D; 14.129 Hz (rounded to 3 d.p.). The only other validation prevents the spectral resolution from exceeding the bandwidth of the largest zoom window. */
    spectralResolutionsHz?: Array<number>;
    /** The total bandwidth of each of the zoom windows in kHz. Combined with the freq_centres_mhz, each must define a spectral window that is contained within the Low frequency range. The value must correspond to the bandwidth of one of seven LOW zoom windows, to within 0.1 kHz. */
    totalBandwidthsKhz?: Array<number>;
}

export interface SkaOstSenscalcLowApiZoomWeightingRequestParams {
    /** Enumeration of the weighting strategy used. */
    weightingMode: 'natural' | 'robust' | 'uniform';
    /** Pointing centre in HH:MM:SS[.ss] [+|-]DD:MM:SS[.ss] */
    pointingCentre: string;
    /** Robust parameter. Only required and considered if the weighting is set to robust. */
    robustness?: -2 | -1 | 0 | 1 | 2;
    /** Enumeration of the SKA LOW subarray configurations allowed for a zoom calculation. To define a custom configuration, set num_stations and do not set this parameter. */
    subarrayConfiguration?: 'LOW_AA2_all' | 'LOW_AA2_core_only' | 'LOW_AAstar_all' | 'LOW_AAstar_core_only' | 'LOW_AA4_all' | 'LOW_AA4_core_only';
    /** Array of the central frequency of each zoom windows in MHz. Combined with the total_bandwidths_khz, each must define a spectral window that is contained within the Low frequency range. */
    freqCentresMhz?: Array<number>;
}


@Injectable({
  providedIn: 'root'
})
export class DefaultService {

    protected basePath = 'http://localhost';
    public defaultHeaders = new HttpHeaders();
    public configuration = new LowConfiguration();
    public encoder: HttpParameterCodec;

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string|string[], @Optional() configuration: LowConfiguration) {
        if (configuration) {
            this.configuration = configuration;
        }
        if (typeof this.configuration.basePath !== 'string') {
            if (Array.isArray(basePath) && basePath.length > 0) {
                basePath = basePath[0];
            }

            if (typeof basePath !== 'string') {
                basePath = this.basePath;
            }
            this.configuration.basePath = basePath;
        }
        this.encoder = this.configuration.encoder || new CustomHttpParameterCodec();
    }


    // @ts-ignore
    private addToHttpParams(httpParams: HttpParams, value: any, key?: string): HttpParams {
        if (typeof value === "object" && value instanceof Date === false) {
            httpParams = this.addToHttpParamsRecursive(httpParams, value);
        } else {
            httpParams = this.addToHttpParamsRecursive(httpParams, value, key);
        }
        return httpParams;
    }

    private addToHttpParamsRecursive(httpParams: HttpParams, value?: any, key?: string): HttpParams {
        if (value == null) {
            return httpParams;
        }

        if (typeof value === "object") {
            if (Array.isArray(value)) {
                (value as any[]).forEach( elem => httpParams = this.addToHttpParamsRecursive(httpParams, elem, key));
            } else if (value instanceof Date) {
                if (key != null) {
                    httpParams = httpParams.append(key, (value as Date).toISOString().substring(0, 10));
                } else {
                   throw Error("key may not be null if value is Date");
                }
            } else {
                Object.keys(value).forEach( k => httpParams = this.addToHttpParamsRecursive(
                    httpParams, value[k], key != null ? `${key}.${k}` : k));
            }
        } else if (key != null) {
            httpParams = httpParams.append(key, value);
        } else {
            throw Error("key may not be null if value is not object or array");
        }
        return httpParams;
    }

    /**
     * Calculates a sensitivity given an integration for the continuum mode.  The result contains a continuum calculation for the full window and a spectral line calculation. These should then each be combined with a response from the weighting endpoint for the respective spectral mode. 
     * @param requestParameters
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public skaOstSenscalcLowApiContinuumCalculate(requestParameters: SkaOstSenscalcLowApiContinuumCalculateRequestParams, observe?: 'body', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<LowContinuumSensitivityResponse>;
    public skaOstSenscalcLowApiContinuumCalculate(requestParameters: SkaOstSenscalcLowApiContinuumCalculateRequestParams, observe?: 'response', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpResponse<LowContinuumSensitivityResponse>>;
    public skaOstSenscalcLowApiContinuumCalculate(requestParameters: SkaOstSenscalcLowApiContinuumCalculateRequestParams, observe?: 'events', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpEvent<LowContinuumSensitivityResponse>>;
    public skaOstSenscalcLowApiContinuumCalculate(requestParameters: SkaOstSenscalcLowApiContinuumCalculateRequestParams, observe: any = 'body', reportProgress: boolean = false, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<any> {
        const subarrayConfiguration = requestParameters.subarrayConfiguration;
        const numStations = requestParameters.numStations;
        const integrationTimeH = requestParameters.integrationTimeH;
        const pointingCentre = requestParameters.pointingCentre;
        const elevationLimit = requestParameters.elevationLimit;
        const freqCentreMhz = requestParameters.freqCentreMhz;
        const spectralAveragingFactor = requestParameters.spectralAveragingFactor;
        const bandwidthMhz = requestParameters.bandwidthMhz;
        const nSubbands = requestParameters.nSubbands;

        let localVarQueryParameters = new HttpParams({encoder: this.encoder});
        if (subarrayConfiguration !== undefined && subarrayConfiguration !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>subarrayConfiguration, 'subarray_configuration');
        }
        if (numStations !== undefined && numStations !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>numStations, 'num_stations');
        }
        if (integrationTimeH !== undefined && integrationTimeH !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>integrationTimeH, 'integration_time_h');
        }
        if (pointingCentre !== undefined && pointingCentre !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>pointingCentre, 'pointing_centre');
        }
        if (elevationLimit !== undefined && elevationLimit !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>elevationLimit, 'elevation_limit');
        }
        if (freqCentreMhz !== undefined && freqCentreMhz !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>freqCentreMhz, 'freq_centre_mhz');
        }
        if (spectralAveragingFactor !== undefined && spectralAveragingFactor !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>spectralAveragingFactor, 'spectral_averaging_factor');
        }
        if (bandwidthMhz !== undefined && bandwidthMhz !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>bandwidthMhz, 'bandwidth_mhz');
        }
        if (nSubbands !== undefined && nSubbands !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>nSubbands, 'n_subbands');
        }

        let localVarHeaders = this.defaultHeaders;

        let localVarHttpHeaderAcceptSelected: string | undefined = options && options.httpHeaderAccept;
        if (localVarHttpHeaderAcceptSelected === undefined) {
            // to determine the Accept header
            const httpHeaderAccepts: string[] = [
                'application/json'
            ];
            localVarHttpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        }
        if (localVarHttpHeaderAcceptSelected !== undefined) {
            localVarHeaders = localVarHeaders.set('Accept', localVarHttpHeaderAcceptSelected);
        }

        let localVarHttpContext: HttpContext | undefined = options && options.context;
        if (localVarHttpContext === undefined) {
            localVarHttpContext = new HttpContext();
        }


        let responseType_: 'text' | 'json' | 'blob' = 'json';
        if (localVarHttpHeaderAcceptSelected) {
            if (localVarHttpHeaderAcceptSelected.startsWith('text')) {
                responseType_ = 'text';
            } else if (this.configuration.isJsonMime(localVarHttpHeaderAcceptSelected)) {
                responseType_ = 'json';
            } else {
                responseType_ = 'blob';
            }
        }

        let localVarPath = `/continuum/calculate`;
        return this.httpClient.request<LowContinuumSensitivityResponse>('get', `${this.configuration.basePath}${localVarPath}`,
            {
                context: localVarHttpContext,
                params: localVarQueryParameters,
                responseType: <any>responseType_,
                withCredentials: this.configuration.withCredentials,
                headers: localVarHeaders,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Retrieve the parameters related to weighting (e.g. beam-size and relative sensitivity). The spectral_mode parameter determines whether results are retrieved for a continuum or spectral (line) observation. 
     * @param requestParameters
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public skaOstSenscalcLowApiContinuumWeighting(requestParameters: SkaOstSenscalcLowApiContinuumWeightingRequestParams, observe?: 'body', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<LowContinuumWeightingResult>;
    public skaOstSenscalcLowApiContinuumWeighting(requestParameters: SkaOstSenscalcLowApiContinuumWeightingRequestParams, observe?: 'response', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpResponse<LowContinuumWeightingResult>>;
    public skaOstSenscalcLowApiContinuumWeighting(requestParameters: SkaOstSenscalcLowApiContinuumWeightingRequestParams, observe?: 'events', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpEvent<LowContinuumWeightingResult>>;
    public skaOstSenscalcLowApiContinuumWeighting(requestParameters: SkaOstSenscalcLowApiContinuumWeightingRequestParams, observe: any = 'body', reportProgress: boolean = false, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<any> {
        const spectralMode = requestParameters.spectralMode;
        if (spectralMode === null || spectralMode === undefined) {
            throw new Error('Required parameter spectralMode was null or undefined when calling skaOstSenscalcLowApiContinuumWeighting.');
        }
        const weightingMode = requestParameters.weightingMode;
        if (weightingMode === null || weightingMode === undefined) {
            throw new Error('Required parameter weightingMode was null or undefined when calling skaOstSenscalcLowApiContinuumWeighting.');
        }
        const pointingCentre = requestParameters.pointingCentre;
        if (pointingCentre === null || pointingCentre === undefined) {
            throw new Error('Required parameter pointingCentre was null or undefined when calling skaOstSenscalcLowApiContinuumWeighting.');
        }
        const freqCentreMhz = requestParameters.freqCentreMhz;
        if (freqCentreMhz === null || freqCentreMhz === undefined) {
            throw new Error('Required parameter freqCentreMhz was null or undefined when calling skaOstSenscalcLowApiContinuumWeighting.');
        }
        const robustness = requestParameters.robustness;
        const subarrayConfiguration = requestParameters.subarrayConfiguration;
        const subbandFreqCentresMhz = requestParameters.subbandFreqCentresMhz;

        let localVarQueryParameters = new HttpParams({encoder: this.encoder});
        if (spectralMode !== undefined && spectralMode !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>spectralMode, 'spectral_mode');
        }
        if (weightingMode !== undefined && weightingMode !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>weightingMode, 'weighting_mode');
        }
        if (robustness !== undefined && robustness !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>robustness, 'robustness');
        }
        if (subarrayConfiguration !== undefined && subarrayConfiguration !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>subarrayConfiguration, 'subarray_configuration');
        }
        if (pointingCentre !== undefined && pointingCentre !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>pointingCentre, 'pointing_centre');
        }
        if (freqCentreMhz !== undefined && freqCentreMhz !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>freqCentreMhz, 'freq_centre_mhz');
        }
        if (subbandFreqCentresMhz) {
            subbandFreqCentresMhz.forEach((element) => {
                localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
                  <any>element, 'subband_freq_centres_mhz');
            })
        }

        let localVarHeaders = this.defaultHeaders;

        let localVarHttpHeaderAcceptSelected: string | undefined = options && options.httpHeaderAccept;
        if (localVarHttpHeaderAcceptSelected === undefined) {
            // to determine the Accept header
            const httpHeaderAccepts: string[] = [
                'application/json'
            ];
            localVarHttpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        }
        if (localVarHttpHeaderAcceptSelected !== undefined) {
            localVarHeaders = localVarHeaders.set('Accept', localVarHttpHeaderAcceptSelected);
        }

        let localVarHttpContext: HttpContext | undefined = options && options.context;
        if (localVarHttpContext === undefined) {
            localVarHttpContext = new HttpContext();
        }


        let responseType_: 'text' | 'json' | 'blob' = 'json';
        if (localVarHttpHeaderAcceptSelected) {
            if (localVarHttpHeaderAcceptSelected.startsWith('text')) {
                responseType_ = 'text';
            } else if (this.configuration.isJsonMime(localVarHttpHeaderAcceptSelected)) {
                responseType_ = 'json';
            } else {
                responseType_ = 'blob';
            }
        }

        let localVarPath = `/continuum/weighting`;
        return this.httpClient.request<LowContinuumWeightingResult>('get', `${this.configuration.basePath}${localVarPath}`,
            {
                context: localVarHttpContext,
                params: localVarQueryParameters,
                responseType: <any>responseType_,
                withCredentials: this.configuration.withCredentials,
                headers: localVarHeaders,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Calculate the sensitivity of an SKA LOW observation in PSS mode for the input parameters.
     * @param requestParameters
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public skaOstSenscalcLowApiPssCalculate(requestParameters: SkaOstSenscalcLowApiPssCalculateRequestParams, observe?: 'body', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<LowPssSensitivityResponse>;
    public skaOstSenscalcLowApiPssCalculate(requestParameters: SkaOstSenscalcLowApiPssCalculateRequestParams, observe?: 'response', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpResponse<LowPssSensitivityResponse>>;
    public skaOstSenscalcLowApiPssCalculate(requestParameters: SkaOstSenscalcLowApiPssCalculateRequestParams, observe?: 'events', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpEvent<LowPssSensitivityResponse>>;
    public skaOstSenscalcLowApiPssCalculate(requestParameters: SkaOstSenscalcLowApiPssCalculateRequestParams, observe: any = 'body', reportProgress: boolean = false, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<any> {
        const subarrayConfiguration = requestParameters.subarrayConfiguration;
        const numStations = requestParameters.numStations;
        const integrationTimeH = requestParameters.integrationTimeH;
        const pointingCentre = requestParameters.pointingCentre;
        const elevationLimit = requestParameters.elevationLimit;
        const freqCentreMhz = requestParameters.freqCentreMhz;
        const dm = requestParameters.dm;
        const intrinsicPulseWidth = requestParameters.intrinsicPulseWidth;
        const pulsePeriod = requestParameters.pulsePeriod;

        let localVarQueryParameters = new HttpParams({encoder: this.encoder});
        if (subarrayConfiguration !== undefined && subarrayConfiguration !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>subarrayConfiguration, 'subarray_configuration');
        }
        if (numStations !== undefined && numStations !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>numStations, 'num_stations');
        }
        if (integrationTimeH !== undefined && integrationTimeH !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>integrationTimeH, 'integration_time_h');
        }
        if (pointingCentre !== undefined && pointingCentre !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>pointingCentre, 'pointing_centre');
        }
        if (elevationLimit !== undefined && elevationLimit !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>elevationLimit, 'elevation_limit');
        }
        if (freqCentreMhz !== undefined && freqCentreMhz !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>freqCentreMhz, 'freq_centre_mhz');
        }
        if (dm !== undefined && dm !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>dm, 'dm');
        }
        if (intrinsicPulseWidth !== undefined && intrinsicPulseWidth !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>intrinsicPulseWidth, 'intrinsic_pulse_width');
        }
        if (pulsePeriod !== undefined && pulsePeriod !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>pulsePeriod, 'pulse_period');
        }

        let localVarHeaders = this.defaultHeaders;

        let localVarHttpHeaderAcceptSelected: string | undefined = options && options.httpHeaderAccept;
        if (localVarHttpHeaderAcceptSelected === undefined) {
            // to determine the Accept header
            const httpHeaderAccepts: string[] = [
                'application/json'
            ];
            localVarHttpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        }
        if (localVarHttpHeaderAcceptSelected !== undefined) {
            localVarHeaders = localVarHeaders.set('Accept', localVarHttpHeaderAcceptSelected);
        }

        let localVarHttpContext: HttpContext | undefined = options && options.context;
        if (localVarHttpContext === undefined) {
            localVarHttpContext = new HttpContext();
        }


        let responseType_: 'text' | 'json' | 'blob' = 'json';
        if (localVarHttpHeaderAcceptSelected) {
            if (localVarHttpHeaderAcceptSelected.startsWith('text')) {
                responseType_ = 'text';
            } else if (this.configuration.isJsonMime(localVarHttpHeaderAcceptSelected)) {
                responseType_ = 'json';
            } else {
                responseType_ = 'blob';
            }
        }

        let localVarPath = `/pss/calculate`;
        return this.httpClient.request<LowPssSensitivityResponse>('get', `${this.configuration.basePath}${localVarPath}`,
            {
                context: localVarHttpContext,
                params: localVarQueryParameters,
                responseType: <any>responseType_,
                withCredentials: this.configuration.withCredentials,
                headers: localVarHeaders,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Returns the array configurations available
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public skaOstSenscalcLowApiSubarrays(observe?: 'body', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<Array<LowSubarraysResponse>>;
    public skaOstSenscalcLowApiSubarrays(observe?: 'response', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpResponse<Array<LowSubarraysResponse>>>;
    public skaOstSenscalcLowApiSubarrays(observe?: 'events', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpEvent<Array<LowSubarraysResponse>>>;
    public skaOstSenscalcLowApiSubarrays(observe: any = 'body', reportProgress: boolean = false, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<any> {

        let localVarHeaders = this.defaultHeaders;

        let localVarHttpHeaderAcceptSelected: string | undefined = options && options.httpHeaderAccept;
        if (localVarHttpHeaderAcceptSelected === undefined) {
            // to determine the Accept header
            const httpHeaderAccepts: string[] = [
                'application/json'
            ];
            localVarHttpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        }
        if (localVarHttpHeaderAcceptSelected !== undefined) {
            localVarHeaders = localVarHeaders.set('Accept', localVarHttpHeaderAcceptSelected);
        }

        let localVarHttpContext: HttpContext | undefined = options && options.context;
        if (localVarHttpContext === undefined) {
            localVarHttpContext = new HttpContext();
        }


        let responseType_: 'text' | 'json' | 'blob' = 'json';
        if (localVarHttpHeaderAcceptSelected) {
            if (localVarHttpHeaderAcceptSelected.startsWith('text')) {
                responseType_ = 'text';
            } else if (this.configuration.isJsonMime(localVarHttpHeaderAcceptSelected)) {
                responseType_ = 'json';
            } else {
                responseType_ = 'blob';
            }
        }

        let localVarPath = `/subarrays`;
        return this.httpClient.request<Array<LowSubarraysResponse>>('get', `${this.configuration.basePath}${localVarPath}`,
            {
                context: localVarHttpContext,
                responseType: <any>responseType_,
                withCredentials: this.configuration.withCredentials,
                headers: localVarHeaders,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Calculates an integration time in seconds given a target sensitivity (or vice-versa) for the zoom mode.  The result contains a spectral line calculation for the given zoom window. This should then each be combined  with a response from the weighting endpoint. 
     * @param requestParameters
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public skaOstSenscalcLowApiZoomCalculate(requestParameters: SkaOstSenscalcLowApiZoomCalculateRequestParams, observe?: 'body', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<Array<LowSingleZoomSensitivityResponse>>;
    public skaOstSenscalcLowApiZoomCalculate(requestParameters: SkaOstSenscalcLowApiZoomCalculateRequestParams, observe?: 'response', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpResponse<Array<LowSingleZoomSensitivityResponse>>>;
    public skaOstSenscalcLowApiZoomCalculate(requestParameters: SkaOstSenscalcLowApiZoomCalculateRequestParams, observe?: 'events', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpEvent<Array<LowSingleZoomSensitivityResponse>>>;
    public skaOstSenscalcLowApiZoomCalculate(requestParameters: SkaOstSenscalcLowApiZoomCalculateRequestParams, observe: any = 'body', reportProgress: boolean = false, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<any> {
        const subarrayConfiguration = requestParameters.subarrayConfiguration;
        const numStations = requestParameters.numStations;
        const integrationTimeH = requestParameters.integrationTimeH;
        const pointingCentre = requestParameters.pointingCentre;
        const elevationLimit = requestParameters.elevationLimit;
        const freqCentresMhz = requestParameters.freqCentresMhz;
        const spectralAveragingFactor = requestParameters.spectralAveragingFactor;
        const spectralResolutionsHz = requestParameters.spectralResolutionsHz;
        const totalBandwidthsKhz = requestParameters.totalBandwidthsKhz;

        let localVarQueryParameters = new HttpParams({encoder: this.encoder});
        if (subarrayConfiguration !== undefined && subarrayConfiguration !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>subarrayConfiguration, 'subarray_configuration');
        }
        if (numStations !== undefined && numStations !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>numStations, 'num_stations');
        }
        if (integrationTimeH !== undefined && integrationTimeH !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>integrationTimeH, 'integration_time_h');
        }
        if (pointingCentre !== undefined && pointingCentre !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>pointingCentre, 'pointing_centre');
        }
        if (elevationLimit !== undefined && elevationLimit !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>elevationLimit, 'elevation_limit');
        }
        if (freqCentresMhz) {
            freqCentresMhz.forEach((element) => {
                localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
                  <any>element, 'freq_centres_mhz');
            })
        }
        if (spectralAveragingFactor !== undefined && spectralAveragingFactor !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>spectralAveragingFactor, 'spectral_averaging_factor');
        }
        if (spectralResolutionsHz) {
            spectralResolutionsHz.forEach((element) => {
                localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
                  <any>element, 'spectral_resolutions_hz');
            })
        }
        if (totalBandwidthsKhz) {
            totalBandwidthsKhz.forEach((element) => {
                localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
                  <any>element, 'total_bandwidths_khz');
            })
        }

        let localVarHeaders = this.defaultHeaders;

        let localVarHttpHeaderAcceptSelected: string | undefined = options && options.httpHeaderAccept;
        if (localVarHttpHeaderAcceptSelected === undefined) {
            // to determine the Accept header
            const httpHeaderAccepts: string[] = [
                'application/json'
            ];
            localVarHttpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        }
        if (localVarHttpHeaderAcceptSelected !== undefined) {
            localVarHeaders = localVarHeaders.set('Accept', localVarHttpHeaderAcceptSelected);
        }

        let localVarHttpContext: HttpContext | undefined = options && options.context;
        if (localVarHttpContext === undefined) {
            localVarHttpContext = new HttpContext();
        }


        let responseType_: 'text' | 'json' | 'blob' = 'json';
        if (localVarHttpHeaderAcceptSelected) {
            if (localVarHttpHeaderAcceptSelected.startsWith('text')) {
                responseType_ = 'text';
            } else if (this.configuration.isJsonMime(localVarHttpHeaderAcceptSelected)) {
                responseType_ = 'json';
            } else {
                responseType_ = 'blob';
            }
        }

        let localVarPath = `/zoom/calculate`;
        return this.httpClient.request<Array<LowSingleZoomSensitivityResponse>>('get', `${this.configuration.basePath}${localVarPath}`,
            {
                context: localVarHttpContext,
                params: localVarQueryParameters,
                responseType: <any>responseType_,
                withCredentials: this.configuration.withCredentials,
                headers: localVarHeaders,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Compute the weighting correction factor to apply to the continuum calculation.  As zoom mode currently only displays the spectral sensitivity/integration time, this weighting endpoint  will always use the \&#39;line\&#39; spectral mode in the look up table. 
     * @param requestParameters
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public skaOstSenscalcLowApiZoomWeighting(requestParameters: SkaOstSenscalcLowApiZoomWeightingRequestParams, observe?: 'body', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<Array<LowSingleWeightingZoomResult>>;
    public skaOstSenscalcLowApiZoomWeighting(requestParameters: SkaOstSenscalcLowApiZoomWeightingRequestParams, observe?: 'response', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpResponse<Array<LowSingleWeightingZoomResult>>>;
    public skaOstSenscalcLowApiZoomWeighting(requestParameters: SkaOstSenscalcLowApiZoomWeightingRequestParams, observe?: 'events', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpEvent<Array<LowSingleWeightingZoomResult>>>;
    public skaOstSenscalcLowApiZoomWeighting(requestParameters: SkaOstSenscalcLowApiZoomWeightingRequestParams, observe: any = 'body', reportProgress: boolean = false, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<any> {
        const weightingMode = requestParameters.weightingMode;
        if (weightingMode === null || weightingMode === undefined) {
            throw new Error('Required parameter weightingMode was null or undefined when calling skaOstSenscalcLowApiZoomWeighting.');
        }
        const pointingCentre = requestParameters.pointingCentre;
        if (pointingCentre === null || pointingCentre === undefined) {
            throw new Error('Required parameter pointingCentre was null or undefined when calling skaOstSenscalcLowApiZoomWeighting.');
        }
        const robustness = requestParameters.robustness;
        const subarrayConfiguration = requestParameters.subarrayConfiguration;
        const freqCentresMhz = requestParameters.freqCentresMhz;

        let localVarQueryParameters = new HttpParams({encoder: this.encoder});
        if (weightingMode !== undefined && weightingMode !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>weightingMode, 'weighting_mode');
        }
        if (robustness !== undefined && robustness !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>robustness, 'robustness');
        }
        if (subarrayConfiguration !== undefined && subarrayConfiguration !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>subarrayConfiguration, 'subarray_configuration');
        }
        if (pointingCentre !== undefined && pointingCentre !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>pointingCentre, 'pointing_centre');
        }
        if (freqCentresMhz) {
            freqCentresMhz.forEach((element) => {
                localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
                  <any>element, 'freq_centres_mhz');
            })
        }

        let localVarHeaders = this.defaultHeaders;

        let localVarHttpHeaderAcceptSelected: string | undefined = options && options.httpHeaderAccept;
        if (localVarHttpHeaderAcceptSelected === undefined) {
            // to determine the Accept header
            const httpHeaderAccepts: string[] = [
                'application/json'
            ];
            localVarHttpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        }
        if (localVarHttpHeaderAcceptSelected !== undefined) {
            localVarHeaders = localVarHeaders.set('Accept', localVarHttpHeaderAcceptSelected);
        }

        let localVarHttpContext: HttpContext | undefined = options && options.context;
        if (localVarHttpContext === undefined) {
            localVarHttpContext = new HttpContext();
        }


        let responseType_: 'text' | 'json' | 'blob' = 'json';
        if (localVarHttpHeaderAcceptSelected) {
            if (localVarHttpHeaderAcceptSelected.startsWith('text')) {
                responseType_ = 'text';
            } else if (this.configuration.isJsonMime(localVarHttpHeaderAcceptSelected)) {
                responseType_ = 'json';
            } else {
                responseType_ = 'blob';
            }
        }

        let localVarPath = `/zoom/weighting`;
        return this.httpClient.request<Array<LowSingleWeightingZoomResult>>('get', `${this.configuration.basePath}${localVarPath}`,
            {
                context: localVarHttpContext,
                params: localVarQueryParameters,
                responseType: <any>responseType_,
                withCredentials: this.configuration.withCredentials,
                headers: localVarHeaders,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
